// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { QueryHandler } from "../../../../../core/decorator/QueryHandlerDecorator";
import { lazyInject } from "../../../../../core/decorator/LazyInjectDecorator";
import { GetAmortizationPaymentAmountQuery, GetAmortizationPaymentAmountQueryResponse, } from "./GetAmortizationPaymentAmountQuery";
import { RPCQueryAdapter } from "../../../../../port/out/rpc/RPCQueryAdapter";
import AccountService from "../../../../service/account/AccountService";
import ContractService from "../../../../service/contract/ContractService";
import { GetAmortizationPaymentAmountQueryError } from "./error/GetAmortizationPaymentAmountQueryError";
let GetAmortizationPaymentAmountQueryHandler = class GetAmortizationPaymentAmountQueryHandler {
    queryAdapter;
    accountService;
    contractService;
    constructor(queryAdapter, accountService, contractService) {
        this.queryAdapter = queryAdapter;
        this.accountService = accountService;
        this.contractService = contractService;
    }
    async execute(query) {
        try {
            const { securityId, amortizationId, tokenHolder } = query;
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const tokenHolderEvmAddress = await this.accountService.getAccountEvmAddress(tokenHolder);
            const res = await this.queryAdapter.getAmortizationPaymentAmount(securityEvmAddress, amortizationId, tokenHolderEvmAddress);
            return new GetAmortizationPaymentAmountQueryResponse(res);
        }
        catch (error) {
            throw new GetAmortizationPaymentAmountQueryError(error);
        }
    }
};
GetAmortizationPaymentAmountQueryHandler = __decorate([
    QueryHandler(GetAmortizationPaymentAmountQuery),
    __param(0, lazyInject(RPCQueryAdapter)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(ContractService)),
    __metadata("design:paramtypes", [RPCQueryAdapter,
        AccountService,
        ContractService])
], GetAmortizationPaymentAmountQueryHandler);
export { GetAmortizationPaymentAmountQueryHandler };
